﻿
# ~~~ coding:Utf-8 ~~~

	# ~~ Imports ~~
import es, popuplib, gamethread, playerlib
	# ~~~~~~~~~~~

	# ~~ Variable Script & Version ~~
__version__ = '1.3'
es.ServerVar("votemute_player", __version__).makepublic()
	# ~~~~~~~~~~~~~~~~~~~~~~~~

	# ~~ Infos EventScripts ~~
info = es.AddonInfo()
info.name = "votemute_player"
info.version = __version__
info.author = "TiTi"
info.url = "http://csswarner.easyforum.fr"
	# ~~~~~~~~~~~~~~~~~~~

player_vote = {}
liste_mute = []

es.ServerVar("nbr_player_min_cfg")
es.ServerVar("pourcent_cfg")

nbr_player_min = es.ServerVar("nbr_player_min_cfg")
pourcent = es.ServerVar("pourcent_cfg")

def load():
	es.log("Chargement du script votemute_player ...")
	es.server.cmd("es_xmexec ../addons/eventscripts/votemute_player/votemute_player.cfg")
		# Appel de la fonction f_liste_mute
	f_liste_mute()
	es.msg("#multi", "#default[#lightgreenvotemute_player#default] #greenScript Load")

def unload():
	es.log("Déchargement du script votemute_player ...")
	es.msg("#multi", "#default[#lightgreenvotemute_player#default] #greenScript Unload")

def player_activate(e):
	global player_vote
	userid = int(e["userid"])
		# On rajoute le joueur dans la liste et on associe 0 qui signifie qu'il n'a voté pour personne
	player_vote[userid] = 0
		# Appel de la fonction send_mess après 5 secondes
	gamethread.delayed(5, send_mess, userid)

def player_disconnect(e):
	global player_vote
	global liste_mute
	userid = int(e["userid"])
		# On supprime le joueur de la liste des votes
	del(player_vote[userid])
	if userid in liste_mute:
			# On supprime le joueur si il était muté
		liste_mute.remove(userid)

def send_mess(userid):
		# On signal au joueur qui arrive que le votemute est présent et utilisable sur le serveur
	es.tell(userid, "#multi", "#greenLe #lightgreen!votemute #greenest à votre disposition. Merci d'en faire bon usage.")

def player_say(e):
	if e["text"] == '!votemute' or e["text"] == '!vm':
		f_votemute_liste(int(e["userid"]))

def f_votemute_liste(userid):
	global votemute_liste
	global liste_mute
	global nbr_player_min
		# Récupération du nombre de joueur sur le serveur
	nbr_player_server = es.getplayercount()
	if nbr_player_server > nbr_player_min:
			# Création de la liste des joueurs
		votemute_liste = popuplib.easymenu("votemute_liste", None, votemute_choix)
		votemute_liste.settitle("Choisit un joueur à muter :")
		playerlist = es.getUseridList()
			# Suppression du joueur qui demande le menu dans la liste
		playerlist.remove(userid)
		for element in liste_mute:
				# Suppresion des joueurs déjà muté de la liste
			playerlist.remove(element)
		for playerid in playerlist:
				# Ajout des choix du menu avec le nom des joueurs
			votemute_liste.addoption(playerid, es.getplayername(playerid))
			# Envoi du menu au joueur qui l'a demandé
		votemute_liste.send(userid)
	else:
		es.msg("#multi", "#greenLe #lightgreen!votemute #greenest disponible seulement avec plus de #default%s #greenjoueurs sur le serveur."%nbr_player_min)

def votemute_choix(userid, choix, popupnom):
	global player_vote
		# Récupération du pseudo du joueur qui à voté
	pseudo_voteur = es.getplayername(int(userid))
		# Récupération du pseudo du joueur qui est victime du vote
	pseudo_vote = es.getplayername(int(choix))
		# Si le joueur à déjà voté pour ce joueur
	if choix == player_vote[userid]:
		es.tell(userid, "#multi", "#greenVous avez déjà voté pour muter #lightgreen%s."%pseudo_vote)
	else:
			# Enregistre le vote du joueur
		player_vote[userid] = choix
			# Détermination du nombre de vote necessaire pour muter un joueur
		pourcent_vote = float(pourcent)
		nbr_vote_nec = int(es.getplayercount()*pourcent_vote)
		i=0
		for val in player_vote:
			if player_vote[val] == choix:
				i+=1
			# Retourne le nombre de joueur ayant voté pour le joueur concerné par le dernier vote
		nbr_vote_joueur = i
			# Determination du nombre de vote restant pour muter un joueur
		nbr_vote_rest = nbr_vote_nec - nbr_vote_joueur
			# Si le nombre de vote restant pour muter le joueur est égal à 0 :
		if nbr_vote_rest == 0:
			es.msg("#multi", "#lightgreen%s #defaultvote pour muter #green%s#default."%(pseudo_voteur,pseudo_vote))
			f_mute(choix)
		else:
			es.msg("#multi", "#lightgreen%s #defaultvote pour muter #green%s#default, #lightgreen%s #defaultvote(s) requis restant."%(pseudo_voteur,pseudo_vote,nbr_vote_rest))

def f_mute(userid):
	global liste_mute
	joueur = playerlib.getPlayer(userid)
		# Récupération du pseudo du joueur à muter
	Pseudo = joueur.attributes["name"]
		# Récupération du steamid du joueur à muter
	SteamId = joueur.attributes["steamid"]
		# Commande qui permet le mute d'un joueur
	es.server.queuecmd("ma_mute "+ SteamId)
		# Affichage du joueur muté
	es.msg("#multi", "#green%s #defaultà été muter par le #lightgreenvotemute#default."%Pseudo)
		# Ajout du joueur muté dans le dico
	liste_mute.append(int(userid))

def f_liste_mute():
	global player_vote
	playerlist = es.getUseridList()
	for playerid in playerlist:
			# Mise à zéro du vote des joueurs lors du démarage du script en cours de map
		player_vote[int(playerid)] = 0

def es_map_start(e):
	global player_vote
	global liste_mute
	for clef in player_vote:
			# Remise à zéro des votes pour tout le monde
		player_vote[clef] = 0
		# Remise à zéro de la liste des joueurs muté
	liste_mute = []